#include <iostream>
#include <cstring>

using namespace std ;

#include "merge.h"

static
bool listEq( const List<char*> &a, const List<char*> &b) {
    if( a.length() == b.length() ) {
        for( int i = 0 ; i < a.length() ; ++i ) 
            if( 0 != strcmp(a.retrieve(i), b.retrieve(i)) ) return false ;
        return true ; }
    else {
        return false ; }
}

static
void call_merge( List<List<char*> > &inLists,
                 List<char*>        &outList,
                 bool             &success )
{
    cout << "INPUT:" << endl ;
    cout << "  < " ;
    for( int i=0 ; i < inLists.length() ; ++i ) {
        if( i!=0 ) cout << "    " ;
        cout << "< " ;
        List<char*> list_i = inLists.retrieveRef(i) ;
        for( int j =0 ; j < list_i.length() ; ++j ) {
            cout << list_i.retrieve(j) ;
            if( j < list_i.length()-1 ) cout << ", " ; }
        cout << " >" ;
        if( i < inLists.length()-1 ) cout << "," << endl ; }
    cout << "  >" << endl ;
    merge( inLists, outList, success ) ;
    cout << "OUTPUT:" << endl ;
    cout << "  success == " << (success?"true":"false") <<endl ;
    if( success ) {
        cout << "  outList == " ;
        cout << "< " ;
        for( int j =0 ; j < outList.length() ; ++j ) {
            cout << outList.retrieve(j) ;
            if( j < outList.length()-1 ) cout << ", " ; }
        cout << " >" << endl ; }
}
        

int testCount() { return 4 ; }

// doTest  --- do one test //
/////////////////////////////
void doTest( int testNumber, int &result ) {
    try {

        bool pass = true ;
        bool success = false ;
        cout << "Test " << testNumber << "\n" ;
        switch( testNumber ) {
        case 0 : {
            // The example from the assignment
            List<char*> empty ;
            List<List<char*> > foo ;
            foo.insert(0, empty ) ;
            foo.insert(1, empty ) ;
            foo.insert(2, empty ) ;

            List<char*> &zero = foo.retrieveRef(0) ;
            zero.insert(0, "eggs" ) ;
            zero.insert(1, "pancakes" ) ;
            zero.insert(2, "spam" ) ;
            
            List<char*> &one  = foo.retrieveRef(1) ;
            one.insert(0, "bread" ) ;
            one.insert(1, "spam" ) ;
            one.insert(2, "spam" ) ;

            List<char*> &two = foo.retrieveRef(2) ;
            two.insert(0, "caviar" ) ;
            two.insert(1, "spam" ) ;

            
            List<char*> out ;
            call_merge( foo, out, success ) ;
            List< char* > expected ;
            char* a[8] = {"bread", "caviar", "eggs", "pancakes",
                           "spam", "spam", "spam", "spam" } ;
            for(int i = 0 ; i < 8 ; ++i ) {expected.insert(i, a[i] ) ; }
            pass = success && listEq( out, expected ) ;
        } break ;
        case 1 : {
            // An empty list
            List<List<char*> > inLists ;
            List<char*> outList ;
            call_merge( inLists, outList, success );
            pass = success && outList.length()==0 ;
        } break ;
        case 2 :{
            // A list containing an empty listexample from the assignment
            List<char*> empty ;
            List<List<char*> > foo ;
            foo.insert(0, empty ) ;
            foo.insert(1, empty ) ;
            foo.insert(2, empty ) ;

            List<char*> &zero = foo.retrieveRef(0) ;
            zero.insert(0, "eggs" ) ;
            zero.insert(1, "pancakes" ) ;
            zero.insert(2, "spam" ) ;
            
            List<char*> &one  = foo.retrieveRef(1) ;

            List<char*> &two = foo.retrieveRef(2) ;
            two.insert(0, "caviar" ) ;
            two.insert(1, "spam" ) ;

            
            List<char*> out ;
            call_merge( foo, out, success ) ;
            List< char* > expected ;
            char* a[5] = {"caviar", "eggs", "pancakes",
                           "spam", "spam" } ;
            for(int i = 0 ; i < 5 ; ++i ) {expected.insert(i, a[i] ) ; }
            pass = success && listEq( out, expected ) ;
        } break ;
        case 3 : {
            //Test the exception handling.
            success = true ;
            List<char*> empty ;
            List<List<char*> > foo ;
            foo.insert(0, empty ) ;
            foo.insert(1, empty ) ;

            List<char*> &zero = foo.retrieveRef(0) ;
            zero.insert(0, "eggs" ) ;
            zero.insert(1, "pancakes" ) ;
            zero.insert(2, "spam" ) ;
            
            List<char*> &one  = foo.retrieveRef(1) ;
            for(int i = 0 ; i < 18 ; ++i ) {one.insert(i, "x" ) ; }
            
            List<char*> out ;
            call_merge( foo, out, success ) ;

            pass = ! success ;
        } break ;
        default : pass = false ;
        } 

        if( pass ) {
            cout << "Test " << testNumber << " passes\n" ;
            result = 0 ; }
        else {
            cout << "Test " << testNumber << " fails\n" ;
            result = 1 ; } }
    catch( ... ) {
        cerr << "Sorry an unanticipated exception occurred\n" ;
        result = 1 ; } }